import type { MessageApiInjection } from 'naive-ui/es/message/src/MessageProvider';

// eslint-disable-next-line @typescript-eslint/no-explicit-any
export function loadingMsgWrapper<T extends (...args: any[]) => Promise<any>>(
	msg: MessageApiInjection,
	func: T
): T {
	return <T>(async (...args: never[]) => {
		const loadMsg = msg.loading('Working', {
			duration: 0,
			closable: false
		});
		try {
			return await func(...args);
		} finally {
			loadMsg.destroy();
		}
	});
}
